﻿using System;
using System.Collections.Generic;
using System.IO;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Grid;

namespace ConsoleAppCore
{
    class Program
    {
        static void Main(string[] args)
        {
            //Create a new PDF document.

            PdfDocument doc = new PdfDocument();

            //Add a page.

            PdfPage page = doc.Pages.Add();

            //Create a PdfGrid.

            PdfGrid pdfGrid = new PdfGrid();

            //Add values to list

            List<object> data = new List<object>();

            Object row1 = new { ID = "E01", Name = "Clay", Name2 = "Clay" , Name3 = "Clay" , Name4 = "Clay" };

            Object row2 = new { ID = "E02", Name = "Thomas", Name2 = "Clay", Name3 = "Clay", Name4 = "Clay" };


            Object row3 = new { ID = "E02E02E02  ", Name = "ThomasThomas ThomasThomas", Name2 = "ClayClay Clay", Name3 = "Clay", Name4 = "Clay" };


            data.Add(row1);

            data.Add(row2);
            data.Add(row3);

            //Add list to IEnumerable

            IEnumerable<object> dataTable = data;

            //Assign data source.

            pdfGrid.DataSource = dataTable;


            PdfStringFormat format  = new PdfStringFormat();

           // Text wrapping between lines when formatting within a rectangle is disabled.
            format.WordWrap = PdfWordWrapType.None;
            ////Text is wrapped by words. If there is a word that is longer than bounds' width, this word is wrapped by characters.
            //format.WordWrap = PdfWordWrapType.Word;
            ////Text is wrapped by words. If there is a word that is longer than bounds' width, it won't be wrapped at all
            //format.WordWrap = PdfWordWrapType.WordOnly;
            //// Text is wrapped by characters. In this case the word at the end of the text line can be split.
            //format.WordWrap = PdfWordWrapType.Character;

            pdfGrid.Columns[0].Format = format;
            pdfGrid.Columns[1].Format = format;
            pdfGrid.Columns[2].Format = format;
            pdfGrid.Columns[3].Format = format;
            pdfGrid.Columns[4].Format = format;



            //Draw grid to the page of PDF document.

            pdfGrid.Draw(page, new Syncfusion.Drawing.PointF(10, 10));

            //Creating the stream object

            MemoryStream stream = new MemoryStream();

            //Save the PDF document to stream.

            doc.Save(stream);

            //If the position is not set to '0' then the PDF will be empty.

            stream.Position = 0;

            //Close the document.

            doc.Close(true);

            //Defining the ContentType for pdf file.

            string contentType = "application/pdf";

            //Define the file name.

            string fileName = "Grid.pdf";

            //Creates a FileContentResult object by using the file contents, content type, and file name.

           FileStream fs = new FileStream(fileName, FileMode.OpenOrCreate, FileAccess.Write);
            stream.WriteTo(fs);
            fs.Dispose();
            stream.Dispose();


        }
    }
}
